open Softcore

module BckMap = Block.LoopingMap

type t = unit BckMap.t ref

let empty            = ref BckMap.empty
let add ls l         = ls := BckMap.add ~key:l ~data:() !ls
let loops_among ls l = Option.is_some (BckMap.find !ls l)
let singleton l      = ref (BckMap.add ~key:l ~data:() BckMap.empty)
let number l         = BckMap.size !l

module Info_lemmas =
  struct
    type t = string ref
    let lemma_to_string = Block.to_string
    let add l ls = ls := !ls ^ lemma_to_string l ^ "\n"
    let to_string t = Printf.sprintf "Lemmas:\n%s\n" !t
    let new_ () = ref ""
  end
