(** Modify information.
 *
 * A very simple type to allow the tagging of some data.
 * The intended use is when a data results of some computation but we don't know if the computation actually made a change to the data.
 * A simple way of checking this is to compare the data before and after computation but this may be slow for big structures.
 * The type "modified" allow to tag the data {e during the computation} to say if it has been, or not, modified.
 *)

type t = Modified | Unmodified

(**
 * @return [Modified] iff one of the input is equal to [Modified]
 *)
val max : t -> t -> t
