(*
 * Just maps variables to strings 
 *)

open Softcore

module Variable =
  struct
    type t = int

    let var_to_string = Hashtbl.create 10
    let string_to_var = Hashtbl.create 10
    let nb_vars = ref 0

    let of_string s = 
      match Hashtbl.find string_to_var s with
      |None ->
          let new_var = !nb_vars in
          (incr nb_vars;
          Hashtbl.add var_to_string ~key:new_var ~data:s; 
          Hashtbl.add string_to_var ~key:s ~data:new_var; 
          new_var)
      |Some v -> v
    let to_string v = Hashtbl.find_exn var_to_string v
    let compare (v1:t) (v2:t) = compare v1 v2
    let equal (v1:t) (v2:t) = v1 = v2
  end

include Variable
