type t = {
  verbose : bool;
  print_lemmas : bool;
}

let gather v l = { verbose = v; print_lemmas = l; }
let all_false = { verbose = false; print_lemmas = false; }
let is_verbose = function
  | { verbose = true; print_lemmas = _ } -> true
  | { verbose = false; print_lemmas = _ } -> false

type 'a t_funs = {
  stat : (Stats.t -> 'a) -> 'a;
  lemma : (Lemmas.Info_lemmas.t -> 'a) -> 'a;
}

let to_funs { verbose = v; print_lemmas = l } ~default ~stats ~lemmas = {
  stat  = (if v then fun f -> f stats else fun _ -> default);
  lemma = (if l then fun f -> f lemmas else fun _ -> default);
}

let to_unit_funs = to_funs ~default:()
let to_string_funs = to_funs ~default:""
